;New MBR code by TomCat/Abaddon

ORG 7C00H
 SUB    BX,BX
 MOV    DS,BX
 MOV    SI,DATA7C
 LES    DI,[SI]
 LSS    CX,[SI]
 CLD
 LODSW
 XCHG   BP,AX
 LODSW
 XCHG   AX,BP
 REP    MOVSB
 MOV    [SI-INT21H+MBR-2],DL    ; SAVE THE DRIVE CODE
 MOV    CL,255
 XCHG   AX,SI
 MOV    [SI-124],AX             ; INT 21H VECTOR
 MOV    [SI-122],BX
 INC    AX
 MOV    [SI-128],AX             ; INT 20H VECTOR
 MOV    [SI-126],BX
 MOV    SP,BX
 PUSH   BX
 MOV    DI,SP
 SUB    AX,AX
 MOV    DS,BP
 MOV    DX,BP
 MOV    WORD [BX],20CDH         ; INT 20H TO OFFSET 0
 STI
 DB     0EAH                    ; FAR JUMP OPCODE
DATA7C:
 DW     256
 DW     2334

INTRO:
 rept 256 { DB ? }

INT21H:
 IRET
INT20H:
 PUSH   CS
 POP    SS
 MOV    SP,7C00H
 STI
 MOV    AX,3
 INT    10H
 PUSH   CS
 POP    ES
 PUSH   CS
 POP    DS
 MOV    SI,SP
 MOV    DI,600H
 MOV    CX,200H
 CLD
 REP    MOVSB
 PUSH   CS
 PUSH   MBR-7C00H+600H
 MOV    DL,80H
RETF

MBR:
 MOV    AL,TXTBAD-7D00H
 MOV    CL,4
search:
 CMP    [DI-66],CH
 JL     found
 JNZ    error
 ADD    DI,16
 LOOP   search
 INT    18H
found:
 CBW
 INT    13H
 MOV    DH,[DI-65]
 MOV    CX,[DI-64]
 MOV    BX,SP
 MOV    AX,201H
 INT    13H
 JNC    loaded
 MOV    DL,80H
 MOV    AL,TXTLOAD-7D00H
 DEC    SI
 JPE    found
error:
 MOV    AH,7
 XCHG   SI,AX
print:
 LODSB
 TEST   AL,AL
halt:
 JZ     halt
 MOV    AH,0EH
 INT    10H
 JMP    print
loaded:
 MOV    AL,TXTNO-7D00H
 CMP    WORD [7DFEH],0AA55H
 JNE    error
 PUSH   ES
 PUSH   BX
RETF

TXTBAD  DB 'Bad table',0
TXTLOAD DB 'Load error',0
TXTNO   DB 'No OS',0

TABLE:
 rept 4*16 { DB ? }

SIGN:
 DW 0AA55H